/**
 * 接口列表文件
 */
import {
	API_STEROOT,
} from '@/common/request/request';
export default {
	userInfo: {
		info: 'https://meta.swdz.com/index.php/api.user/info?uniacid=5059'
	},


	conf: {
		getGroupConf: {
			url: "conf/getGroupConf",
			auth: false,
			method: "GET", //全局信息
		}
	},
	template: {
		list: {
			url: "template/list",
			auth: false,
			method: "GET", //全局信息
		},
		info: {
			url: "template/info",
			auth: false,
			method: "GET", //全局信息
		}
	},
	digit: {
		digitCheckText: {
			url: "ai/digit",
			auth: true,
			method: "POST",
		},
	},
	ys: {
		checkDescribe: {
			url: "describe/checkDescribe",
			auth: true,
			method: "POST",
		},
		templateList: {
			url: "describe/getTemplateList",
			auth: false,
			method: "POST",
		},
		addFaceTask: {
			url: "describe/addFaceTask",
			auth: true,
			method: "POST",
		},
	},
	ai: {
		digitCheckText: {
			url: "digit/checkText",
			auth: true,
			method: "POST",
		},
		chat: {
			url: "ai/chat",
			auth: true,
			method: "POST",
		},
		chat4: {
			url: "ai/chat4",
			auth: false,
			method: "POST",
		},

		baidu: {
			url: "ai/chatBaidu",
			auth: false,
			method: "POST",
		},
		chat4event: {
			url: "ai/chat4event",
			auth: false,
			method: "POST",
		},
		getProxy: {
			url: "ai/getProxy",
			auth: true,
			method: "GET",
		},
		test: {
			url: "ai/test",
			auth: false,
			method: "POST",
		},
		getAddress: {
			url: "ai/getAddress",
			auth: true,
			method: "GET",
		},
		checkText: {
			url: "ai/checkText",
			auth: true,
			method: "GET",
		},
		painting: {
			url: "ai/painting",
			auth: true,
			method: "POST",
		},
		showTask: {
			url: "ai/showTask",
			auth: true,
			method: "GET",
		},
		tts: {
			url: "ai/tts",
			auth: true,
			method: "POST",
		},
		ttsJob: {
			url: "ai/ttsJob",
			auth: true,
			method: "GET",
		},
		recognizer: {
			url: "ai/recognizer",
			auth: true,
			method: "POST",
		}
	},

	robot: {
		robotApplay: {
			url: "user/robotApply",
			auth: true,
			method: "POST",
		},
		createRobot: {
			url: "robot/createRobot",
			auth: true,
			method: "POST",
		},

		checkRobotIsScan: {
			url: "robot/checkRobotIsScan",
			auth: true,
			method: "POST",
		},
		info: {
			url: "user/info",
			auth: true,
			method: "POST",
		},
	},

	digitalMen: {

		workList: {
			url: "Digit/list",
			auth: false,
			method: "POST",
		},
		generateWork: {
			url: "Digit/addDigit",
			auth: true,
			method: "POST",
		},
		delWork: {
			url: "Digit/deleteDigit",
			auth: true,
			method: "POST",
		},
		roleList: {
			url: "Digit/getRoleList",
			auth: false,
			method: "POST",
		},

		voiceList: {
			url: "Digit/getAudioList",
			auth: false,
			method: "POST",
		},

		backList: {
			url: "Digit/getBackList",
			auth: false,
			method: "POST",
		},
		draftList: {
			url: "Digit/draftList",
			auth: true,
			method: "POST",
		},
		getBg: {
			url: "Digit/getBackImageByRole",
			auth: false,
			method: "POST",
		},


	},
	gallery: {
		getOpensdDetail: {
			url: "gallery/getOpensdDetail",
			auth: true,
			method: "GET",
		},
		list: {
			url: "gallery/list",
			auth: true,
			method: "GET",
		},
		del: {
			url: "gallery/del",
			auth: true,
			method: "POST",
		},
		getWords: {
			url: "gallery/getWords",
			auth: false,
			method: "GET",
		},
		getModels: {
			url: "gallery/getModels",
			auth: false,
			method: "GET",
		},
		create: {
			url: "gallery/create",
			auth: true,
			method: "POST",
		},
		chat: {
			url: "gallery/chat",
			auth: true,
			method: "POST",
		},
		all: {
			url: "gallery/all",
			auth: false,
			method: "GET",
		},
		fetch: {
			url: "gallery/fetch",
			auth: true,
			method: "GET",
		},
		detail: {
			url: "gallery/detail",
			auth: false,
			method: "GET",
		},
		imagine: {
			url: "gallery/imagine",
			auth: true,
			method: "POST",
		},
		getAsyncResult: {
			url: "gallery/getAsyncResult",
			auth: true,
			method: "GET",
		},
		upscale: {
			url: "gallery/upscale",
			auth: true,
			method: "POST",
		},
		variation: {
			url: "gallery/variation",
			auth: true,
			method: "POST",
		},
		setOpen: {
			url: "gallery/setOpen",
			auth: true,
			method: "POST",
		},
		test: {
			url: "gallery/test",
			auth: true,
			method: "POST",
		}
	},
	commission: {
		addTeam: {
			url: "commission/addTeam",
			auth: false,
			method: "POST", //绑定分享关系
		},
		teamList: {
			url: "commission/teamList",
			auth: false,
			method: "GET", //首页信息
		},
		auth: {
			url: "commission/auth",
			auth: false,
			method: "GET", //分销商信息
		},
		apply: {
			url: "commission/apply",
			auth: false,
			method: "POST", //申请成为分销商
		},
		incomeLog: {
			url: "commission/incomeLog",
			auth: false,
			method: "GET", //我的佣金收入明细
		},
		cashoutLog: {
			url: "commission/cashoutLog",
			auth: false,
			method: "GET", //提现记录
		},
		extract: {
			url: "commission/extract",
			auth: false,
			method: "POST", //申请提现
		},
		ranking: {
			url: "commission/ranking",
			auth: false,
			method: "GET", //分销排行榜
		},
		update: {
			url: "commission/update",
			auth: false,
			method: "POST", //提现信息
		},
		create: {
			url: "commission/create",
			auth: false,
			method: "POST", //付费成为分销商下单
		}
	},
	question: {
		list: {
			url: "question/list",
			auth: false,
			method: "GET", //对话记录
		},
		my: {
			url: "question/my",
			auth: false,
			method: "GET", //对话记录
		},
		add: {
			url: "question/add",
			auth: false,
			method: "POST", //对话记录
		},
		del: {
			url: "question/del",
			auth: false,
			method: "POST", //对话记录删除
		}
	},
	city: {
		list: {
			url: "city/list",
			auth: false,
			method: "GET", //图片上传
		},
	},
	common: {
		upload: {
			url: "common/upload",
			auth: false,
			method: "POST", //图片上传
		},
		del_pic: {
			url: "common/del_pic",
			auth: false,
			method: "POST", //图片删除
		},
		template: {
			url: "common/template",
			auth: false,
			method: "GET", //模板数据
		},
		sendMobileCode: {
			url: "common/sendMobileCode",
			auth: false,
			method: "POST", //验证码
		},
		qrcodePath: {
			url: "common/qrcodePath",
			auth: false,
			method: "GET", //二维码数据
		}
	},
	wechat: {
		miniappSilenceAuth: {
			url: "wechat/miniappSilenceAuth",
			auth: false,
			method: "POST", //微信小程序静默登录
		},
		miniappAuth: {
			url: "wechat/miniappAuth",
			auth: false,
			method: "POST", //小程序登录
		},
		authBindindPhone: {
			url: "wechat/authBindindPhone",
			auth: false,
			method: "POST", //手机号登录
		},
		wechatJssdk: {
			url: "wechat/wechatJssdk",
			auth: false,
			method: "GET",
		},
		wechatAuth: {
			url: "wechat/wechatAuth",
			auth: false,
			method: "GET",
		},
		authBindindPhoneCode: {
			url: "wechat/authBindindPhoneCode",
			auth: false,
			method: "POST", //手机号登录
		}
	},
	user: {
		newLogin: {
			url: "user/login_code",
			auth: false,
			method: "POST", //验证码
		},
		code: {
			url: "common/sendMobileCode",
			auth: false,
			method: "POST", //验证码
		},
		info: {
			url: "user/info",
			auth: true,
			method: "POST", //用户信息
		},
		profile: {
			url: "user/profile",
			auth: true,
			method: "POST", //修改用户信息
		},
		userData: {
			url: "user/userData",
			auth: true,
			method: "GET", //用户重要信息
		},
		login: {
			url: "user/login",
			auth: false,
			method: "POST", //用户登录
		},
		register: {
			url: "user/register",
			auth: false,
			method: "POST", //用户注册
		}
	},
	order: {
		create: {
			url: "order/create",
			auth: true,
			method: "POST", //创建订单
		},
		detail: {
			url: "order/detail",
			auth: true,
			method: "GET", //订单详情
		},
		my: {
			url: "order/my",
			auth: true,
			method: "GET", //订单记录
		},
		createSettle: {
			url: "order/createSettle",
			auth: true,
			method: "POST", //创建订单
		},
		detailSettle: {
			url: "order/detailSettle",
			auth: true,
			method: "GET", //入驻订单详情
		}
	},
	pay: {
		prepay: {
			url: "pay/prepay",
			auth: true,
			method: "POST", //微信预支付
		},
		hupijiaopay: {
			url: "pay/hupijiaopay",
			auth: true,
			method: "POST", //虎皮椒预支付
		}
	},
	member: {
		list: {
			url: "member/list",
			auth: false,
			method: "GET", //会员列表
		},
		addCoin: {
			url: "member/addCoin",
			auth: false,
			method: "POST", //奖励金币
		},
		reduceCoin: {
			url: "member/reduceCoin",
			auth: false,
			method: "POST", //消费金币
		},
		bill: {
			url: "member/bill",
			auth: false,
			method: "GET", //记录
		},
		kami: {
			url: "member/kami",
			auth: false,
			method: "POST", //卡密兑换
		}
	},
	more: {
		list: {
			url: "more/list",
			auth: false,
			method: "GET", //更多好玩列表
		},
		visit: {
			url: "more/visit",
			auth: false,
			method: "POST", //增加在玩记录
		},
	},
	messageSystem: {
		list: {
			url: "messageSystem/list",
			auth: false,
			method: "GET", //消息列表
		},
		detail: {
			url: "messageSystem/detail",
			auth: false,
			method: "GET", //消息详情
		},
		new: {
			url: "messageSystem/new",
			auth: false,
			method: "GET", //最新
		}
	},
	chat: {
		getList: {
			url: "chat/getList",
			auth: false,
			method: "GET", //聊天列表
		},
		getChatHistoryConent: {
			url: "chat/getChatHistoryConent",
			auth: false,
			method: "GET", //获取历史聊天对话内容记录
		},
		getHead: {
			url: "chat/getHead",
			auth: false,
			method: "GET", //获得聊天双方头像
		},
		saveMessage: {
			url: "chat/saveMessage",
			auth: false,
			method: "POST", //保存信息
		},
		setRead: {
			url: "chat/setRead",
			auth: false,
			method: "POST", //设置未读消息为已读
		},
		getChatCode: {
			url: "chat/getChatCode",
			auth: false,
			method: "GET", //获取聊天code
		}
	}
};